/* some very simple memory management routines */

#include "dream.h"
#include "mem.h"

#define HEAPSIZE 2000000

static char my_heap[HEAPSIZE];

char *heap_ptr;


char *malloc(long size) 
{
 char *result;
 unsigned int temp;
 unsigned int new_size = size + 32;
 if(heap_ptr + new_size <= heap_ptr + HEAPSIZE)
   {
      temp = (int) heap_ptr + 16;
      result = (char *) ((temp) & 0xFFFFFFF0);
      heap_ptr += new_size;
      memset(result, 0, size); 
   }
 else
   {
      printf("ERROR: Out of memory\r\n");
      result = NULL;
   }
  return result;
}


/*char *memset(char *s, char c, size_t n)
{
 int i;

 for(i = 0; i < n; i++)
   {
     *(char *)(s + i) = c;
   }
 
 return s;
}*/

void init_mem(void)
{
 heap_ptr = my_heap;
}

int free(char *memaddr)
{
 return 0;
}
